#include <SDL2/SDL.h>
#include <iostream>
#include <cmath>
#include <memory>

#include "sprite.h"
 
SDL_Window*   window;
SDL_Renderer* renderer;

std::unique_ptr<Sprite> bob;

int newI;

void initialise() {
    SDL_Init( SDL_INIT_EVERYTHING );
    window  = SDL_CreateWindow("SDL Window", 0, 0, 640, 480, 0);
    renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
    SDL_RenderSetLogicalSize( renderer, 640, 480 );
}

void loadSprites() {
    // Load sprite
    bob = std::make_unique<Sprite> ("bob.bmp", renderer);
}

void update() {
        int x, y, w, h;
        int xc = 320;
        int yc = 240;
        w = 200 + cos(newI*1.0/10)*100;
        h = w;
        x = xc - w/2;
        y = yc - h/2;

   bob->move(x,y);
   bob->resize(w,h);
}

void draw() {
      // Clean scren
      SDL_SetRenderDrawColor( renderer, 0, 0, 0, 255 );
      SDL_RenderClear( renderer );

      bob->draw();
    
      // Display
      SDL_RenderPresent( renderer);
}


int main() {
  initialise();
  loadSprites();

  std::cout << "[Debug] Loaded." << std::endl;

  for(int i = 0; i < 1000; ++i) {
    newI = i;
    update();
    draw();
  }
}
