#include <SDL2/SDL.h>
#include <iostream>
#include <cmath>
#include <memory>
#include <vector>

#include "sprite.h"
 
SDL_Window*   window;
SDL_Renderer* renderer;

// All sprites
std::vector<std::unique_ptr<Sprite>> sprites;

int newI;

void initialise() {
    SDL_Init( SDL_INIT_EVERYTHING );
    window  = SDL_CreateWindow("SDL Window", 0, 0, 640, 480, 0);
    renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
    SDL_RenderSetLogicalSize( renderer, 640, 480 );
}

void loadSprites() {
    // Load sprite
    sprites.push_back( std::make_unique<Sprite> ("bob.bmp", renderer) );
    sprites.push_back( std::make_unique<Sprite> ("bob.bmp", renderer) );
    sprites.push_back( std::make_unique<Sprite> ("bob.bmp", renderer) );
}

void update() {
   int x, y, w, h;
   int xc = 320;
   int yc = 240;
   int i = 0;
   float angle = 2 * M_PI / sprites.size();    
   float phi = newI * 1.0/50;

   w = 100;
   h = 200;

   for (sprite : sprites) {
     sprite->resize(w, h);
     sprite->move(xc - w/2 + cos(angle * i + phi)*200, yc - h / 2+ sin(angle*i + phi)*200);
     ++i;
   }
}

void draw() {
      // Clean scren
      SDL_SetRenderDrawColor( renderer, 0, 0, 0, 255 );
      SDL_RenderClear( renderer );
 
      for (sprite : sprites) {
        sprite->draw();
      }

    
      // Display
      SDL_RenderPresent( renderer);
}


int main() {
  initialise();
  loadSprites();

  std::cout << "[Debug] Loaded." << std::endl;

  for(int i = 0; i < 1000; ++i) {
    newI = i;
    update();
    draw();
  }
}
